#include <iostream>
#include "binaryTree.hh"

Node::Node():
  _label(-1),
  _left(nullptr),
  _right(nullptr) { 
}

Node::Node(int aLabel) :
  _label(aLabel),
  _left(nullptr),
  _right(nullptr) { 
}

Node::Node(const Node& aNode) 
  :_label(aNode._label),
   _left(nullptr),
   _right(nullptr)
{
  std::cout << "COPY NODE #" << _label << std::endl;
  if (aNode._left) {
    _left = new Node(*(aNode._left));
  }
  if (aNode._right) {
    _right = new Node(*(aNode._right));
  }
}

Node::~Node() {
  delete _left;
  delete _right;
}

void Node::print() const {
  std::cout << "(";
  if (_left) {
    _left->print();
  }

  std::cout << _label;

  if (_right) {
    _right->print();
  }

  std::cout << ")";
}

void Node::setLeftChild(Node* aLeft) {
  _left = aLeft;
}

void Node::setRightChild(Node* aRight) {
  _right = aRight;
}

const Node* Node::getLeftChild() const {
  return _left;
}

const Node* Node::getRightChild() const {
  return _right;
}

Node* Node::getLeftChild() {
  return _left;
}

Node* Node::getRightChild() {
  return _right;
}

int Node::getLabel() const {
  return _label;
}

Node& Node::operator=(const Node& aNode) {
  if (&aNode != this) {
    delete _left;
    delete _right;

		_label = aNode._label;

    if (aNode._left) {
      _left = new Node(*(aNode._left));
    }
    
    if (aNode._right) {
      _right = new Node(*(aNode._right));
    }
  }
  return *this;
}
 
