#ifndef BINARY_TREE_HH
#define BINARY_TREE_HH

class Node {
  public:
    // Constructors
    Node();
    Node(int aLabel);
    // Copy Constructor
    Node(const Node& aNode);
    // Destructor
    ~Node();
    // Assignment Operator
    Node& operator=(const Node& aNode);

    void print() const;
    void setLeftChild(Node* aLeft);
    void setRightChild(Node* aRight);
    const Node* getLeftChild() const;
    const Node* getRightChild() const;
    Node* getLeftChild();
    Node* getRightChild();

    int getLabel() const;
  
  private:
    int _label;
    // left and right child nodes
    Node* _left;
    Node* _right;
};

#endif
